diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lfo_run__.cc
--- a/src/__lfo_run__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lfo_run__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -226,13 +226,6 @@
       Matrix solved_vec      = mat.solve (vec);
       double *solved_vec_arr = solved_vec.fortran_vec ();
 
-    // If errors were raised (a singular matrix was encountered), 
-    // there is no sense in countinuing
-    if (error_state)
-      {
-        return ;
-      }
-
       newcast[i]=foreav[i];
       for (octave_idx_type j=0;j<dim;j++) {
         for (octave_idx_type j1=0;j1<embed;j1++) {
@@ -330,87 +323,76 @@
         for (octave_idx_type i=0;i<hdim;i++)
           cast[i][j]=series[j][LENGTH-hdim+i];
 
-      if ( ! error_state)
-        {
-
-          // Promote warnings connected with singular matrixes to errors
-          set_warning_state ("Octave:nearly-singular-matrix","error");
-          set_warning_state ("Octave:singular-matrix","error");
+      // Promote warnings connected with singular matrixes to errors
+      set_warning_state ("Octave:nearly-singular-matrix","error");
+      set_warning_state ("Octave:singular-matrix","error");
 
-          // Calculate the maximum epsilon that makes sense
-          // On the basis of 'i' and 'j' from put_in_boxes ()
-          NDArray input_max = input.max ();
-          double maximum_epsilon = (input_max(0) > input_max(dim-1))
-                                   ? input_max(0) : input_max(dim-1);
-          maximum_epsilon *= EPSF;
+      // Calculate the maximum epsilon that makes sense
+      // On the basis of 'i' and 'j' from put_in_boxes ()
+      NDArray input_max = input.max ();
+      double maximum_epsilon = (input_max(0) > input_max(dim-1))
+                               ? input_max(0) : input_max(dim-1);
+      maximum_epsilon *= EPSF;
 
-          // Create output
-          Matrix output (FLENGTH, dim);
-          for (octave_idx_type i=0;i<FLENGTH;i++)
+      // Create output
+      Matrix output (FLENGTH, dim);
+      for (octave_idx_type i=0;i<FLENGTH;i++)
+        {
+          bool done=0;
+          double epsilon=EPS0/EPSF;
+          while (!done) 
             {
-              bool done=0;
-              double epsilon=EPS0/EPSF;
-              while (!done) 
+              // If epsilon became too large 
+              // there is no sense in continuing
+              if (epsilon > maximum_epsilon)
                 {
-                  // If epsilon became too large 
-                  // there is no sense in continuing
-                  if (epsilon > maximum_epsilon)
+                  error_with_id ("Octave:tisean", "The neighbourhood size"
+                                 " became too large during search,"
+                                 " no sense continuing");
+                  return retval;
+                }
+
+              epsilon*=EPSF;
+              put_in_boxes(series, LENGTH, list, box, epsilon, dim, embed,
+                           DELAY);
+              octave_idx_type actfound;
+              actfound=hfind_neighbors (series, cast, found, list, box,
+                                        epsilon, dim, embed, DELAY);
+              if (actfound >= MINN)
+                {
+                  if (!do_zeroth)
+                    make_fit(series, cast, found, dim, embed, DELAY,
+                             actfound, newcast);
+                  else
+                    make_zeroth(series, found, dim, actfound,newcast);
+
+                  for (octave_idx_type j=0;j<dim;j++)
                     {
-                      error_with_id ("Octave:tisean", "The neighbourhood size"
-                                     " became too large during search,"
-                                     " no sense continuing");
-                      return retval;
+                  // old printf("%e ",newcast[j]*interval[j]+min_array[j]);
+                      output(i,j) = newcast[j]*interval[j]+min_array[j];
                     }
 
-                  epsilon*=EPSF;
-                  put_in_boxes(series, LENGTH, list, box, epsilon, dim, embed,
-                               DELAY);
-                  octave_idx_type actfound;
-                  actfound=hfind_neighbors (series, cast, found, list, box,
-                                            epsilon, dim, embed, DELAY);
-                  if (actfound >= MINN)
+                  done=1;
+                  for (octave_idx_type j=0;j<dim;j++) 
                     {
-                      if (!do_zeroth)
-                        make_fit(series, cast, found, dim, embed, DELAY,
-                                 actfound, newcast);
-                      else
-                        make_zeroth(series, found, dim, actfound,newcast);
-
-                      // Checking if the fit was correct
-                      // If any errors were raised: end function
-                      if (error_state)
+                      // If this occurs there is no sense to continue
+                      if ((newcast[j] > 2.0) || (newcast[j] < -1.0)) 
                         {
+                          error_with_id("Octave:tisean","forecast failed, "
+                                        "escaping data region");
                           return retval;
                         }
-
-                      for (octave_idx_type j=0;j<dim;j++)
-                        {
-                      // old printf("%e ",newcast[j]*interval[j]+min_array[j]);
-                          output(i,j) = newcast[j]*interval[j]+min_array[j];
-                        }
-
-                      done=1;
-                      for (octave_idx_type j=0;j<dim;j++) 
-                        {
-                          // If this occurs there is no sense to continue
-                          if ((newcast[j] > 2.0) || (newcast[j] < -1.0)) 
-                            {
-                              error_with_id("Octave:tisean","forecast failed, "
-                                            "escaping data region");
-                              return retval;
-                            }
-                        }
-                      double *swap=cast[0];
-                      for (octave_idx_type j=0;j<hdim-1;j++)
-                        cast[j]=cast[j+1];
-                      cast[hdim-1]=swap;
-                      for (octave_idx_type j=0;j<dim;j++)
-                        cast[hdim-1][j]=newcast[j];
                     }
+                  double *swap=cast[0];
+                  for (octave_idx_type j=0;j<hdim-1;j++)
+                    cast[j]=cast[j+1];
+                  cast[hdim-1]=swap;
+                  for (octave_idx_type j=0;j<dim;j++)
+                    cast[hdim-1][j]=newcast[j];
                 }
             }
-          retval(0) = output;
         }
+      retval(0) = output;
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lfo_test__.cc
--- a/src/__lfo_test__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lfo_test__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -212,13 +212,6 @@
       Matrix solved_vec      = mat.solve (vec);
       double *solved_vec_arr = solved_vec.fortran_vec ();
 
-      // If errors were raised (a singular matrix was encountered), 
-      // there is no sense in countinueing
-      if (error_state)
-      {
-        return ;
-      }
-
       newcast[i]=foreav[i];
       for (octave_idx_type j=0;j<DIM;j++) {
         octave_idx_type hcj=indexes[0][j];
@@ -332,90 +325,81 @@
       for (octave_idx_type i=0;i<COMP;i++)
         error_array[i]=0.0;
 
-      if ( ! error_state)
-        {
-
-          // Promote warnings connected with singular matrixes to errors
-          set_warning_state ("Octave:nearly-singular-matrix","error");
-          set_warning_state ("Octave:singular-matrix","error");
+      // Promote warnings connected with singular matrixes to errors
+      set_warning_state ("Octave:nearly-singular-matrix","error");
+      set_warning_state ("Octave:singular-matrix","error");
 
-          // Calculate the maximum epsilon that makes sense
-          // On the basis of 'i' and 'j' from put_in_boxes ()
-          NDArray input_max = input.max ();
-          double maximum_epsilon = (input_max(0) > input_max(COMP-1))
-                                   ? input_max(0) : input_max(COMP-1);
-          maximum_epsilon *= EPSF;
+      // Calculate the maximum epsilon that makes sense
+      // On the basis of 'i' and 'j' from put_in_boxes ()
+      NDArray input_max = input.max ();
+      double maximum_epsilon = (input_max(0) > input_max(COMP-1))
+                               ? input_max(0) : input_max(COMP-1);
+      maximum_epsilon *= EPSF;
 
-          // Calculate output
-          bool alldone=0;
-          while (!alldone) {
-            alldone=1;
+      // Calculate output
+      bool alldone=0;
+      while (!alldone) {
+        alldone=1;
 
-            // If epsilon became too large there is no sense in continuing
-            if (epsilon > maximum_epsilon)
-              {
-                error_with_id ("Octave:tisean", "The neighbourhood size became"
-                               " too large during search, no sense"
-                               " continuing");
-                return retval;
-              }
-            epsilon*=EPSF;
-            put_in_boxes(series, LENGTH, STEP, COMP, hdim, epsilon, list, box);
-            for (octave_idx_type i=(EMBED-1)*DELAY;i<clength;i++)
-              if (!done[i]) 
-                {
+        // If epsilon became too large there is no sense in continuing
+        if (epsilon > maximum_epsilon)
+          {
+            error_with_id ("Octave:tisean", "The neighbourhood size became"
+                           " too large during search, no sense"
+                           " continuing");
+            return retval;
+          }
+        epsilon*=EPSF;
+        put_in_boxes(series, LENGTH, STEP, COMP, hdim, epsilon, list, box);
+        for (octave_idx_type i=(EMBED-1)*DELAY;i<clength;i++)
+          if (!done[i]) 
+            {
 
-                  octave_idx_type actfound;
-                  actfound=hfind_neighbors(series, indexes, COMP, hdim, DIM,
-                                           epsilon, hfound, list, box, i);
-                  actfound=exclude_interval(actfound,i-causal+1,
-                                      i+causal+(EMBED-1)*DELAY-1,hfound,found);
-                  if (actfound > MINN) 
-                    {
-                      make_fit(series, indexes, found, STEP, DIM, COMP,
-                               actfound,i,newcast);
-                      // Checking if the fit was correct
-                      // If any errors were raised: end function
-                      if (error_state)
-                        {
-                          return retval;
-                        }
-                      for (octave_idx_type j=0;j<COMP;j++)
-                        error_array[j] += sqr(newcast[j]-series[j][i+STEP]);
+              octave_idx_type actfound;
+              actfound=hfind_neighbors(series, indexes, COMP, hdim, DIM,
+                                       epsilon, hfound, list, box, i);
+              actfound=exclude_interval(actfound,i-causal+1,
+                                  i+causal+(EMBED-1)*DELAY-1,hfound,found);
+              if (actfound > MINN) 
+                {
+                  make_fit(series, indexes, found, STEP, DIM, COMP,
+                           actfound,i,newcast);
+                  // Checking if the fit was correct
+                  for (octave_idx_type j=0;j<COMP;j++)
+                    error_array[j] += sqr(newcast[j]-series[j][i+STEP]);
 
-                      for (octave_idx_type j=0;j<COMP;j++)
-                        individual[j][i]=(newcast[j]-series[j][i+STEP])
-                                          *interval[j];
-                      done[i]=1;
-                    }
-                  alldone &= done[i];
+                  for (octave_idx_type j=0;j<COMP;j++)
+                    individual[j][i]=(newcast[j]-series[j][i+STEP])
+                                      *interval[j];
+                  done[i]=1;
                 }
-          }
+              alldone &= done[i];
+            }
+      }
 
-          double norm=((double)clength-(double)((EMBED-1)*DELAY));
+      double norm=((double)clength-(double)((EMBED-1)*DELAY));
 
-          // Create relative forecast error output
-          Matrix rel (COMP, 1);
-          for (octave_idx_type i=0;i<COMP;i++) 
-            {
-             // old fprintf(stdout,"# %e\n",sqrt(error_array[i]/norm)/rms[i]);
-              rel(i,0) = sqrt(error_array[i]/norm)/rms[i];
-            }
+      // Create relative forecast error output
+      Matrix rel (COMP, 1);
+      for (octave_idx_type i=0;i<COMP;i++) 
+        {
+         // old fprintf(stdout,"# %e\n",sqrt(error_array[i]/norm)/rms[i]);
+          rel(i,0) = sqrt(error_array[i]/norm)/rms[i];
+        }
 
-          // Create individual forecast error output
-          Matrix ind (clength - (EMBED-1)*DELAY,COMP);
-          for (octave_idx_type i=(EMBED-1)*DELAY;i<clength;i++)
+      // Create individual forecast error output
+      Matrix ind (clength - (EMBED-1)*DELAY,COMP);
+      for (octave_idx_type i=(EMBED-1)*DELAY;i<clength;i++)
+        {
+          for (octave_idx_type j=0;j<COMP;j++)
             {
-              for (octave_idx_type j=0;j<COMP;j++)
-                {
-                 // old fprintf(stdout,"%e ",individual[j][i]);
-                  ind(i-(EMBED-1)*DELAY, j) = individual[j][i];
-                }
+             // old fprintf(stdout,"%e ",individual[j][i]);
+              ind(i-(EMBED-1)*DELAY, j) = individual[j][i];
             }
+        }
 
-          retval(0) = rel;
-          retval(1) = ind;
-        }
+      retval(0) = rel;
+      retval(1) = ind;
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lyap_k__.cc
--- a/src/__lyap_k__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lyap_k__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -211,70 +211,67 @@
         eps_fak=pow(epsmax/epsmin,1.0/(double)(epscount-1));
 
 
-      if (! error_state)
+      // Calculate exponents
+      dim_vector dv (epscount ,((int)maxdim-(int)mindim + 1));
+      string_vector keys;
+      keys.append (std::string("eps"));
+      keys.append (std::string("dim"));
+      keys.append (std::string("exp"));
+      octave_map output (dv,keys);
+
+      for (octave_idx_type l=0;l<epscount;l++)
         {
-          // Calculate exponents
-          dim_vector dv (epscount ,((int)maxdim-(int)mindim + 1));
-          string_vector keys;
-          keys.append (std::string("eps"));
-          keys.append (std::string("dim"));
-          keys.append (std::string("exp"));
-          octave_map output (dv,keys);
-
-          for (octave_idx_type l=0;l<epscount;l++)
+          double epsilon=epsmin*pow(eps_fak,(double)l);
+          for (octave_idx_type i=0;i<maxdim-1;i++)
+            for (octave_idx_type j=0;j<=maxiter;j++) {
+               count[i][j]=0;
+               lyap[i][j]=0.0;
+            }
+          put_in_boxes(series, liste, box, length, maxdim, delay, maxiter, 
+                       epsilon);
+          for (octave_idx_type i=0;i<reference;i++)
             {
-              double epsilon=epsmin*pow(eps_fak,(double)l);
-              for (octave_idx_type i=0;i<maxdim-1;i++)
-                for (octave_idx_type j=0;j<=maxiter;j++) {
-                   count[i][j]=0;
-                   lyap[i][j]=0.0;
-                }
-              put_in_boxes(series, liste, box, length, maxdim, delay, maxiter, 
-                           epsilon);
-              for (octave_idx_type i=0;i<reference;i++)
-                {
-                  lfind_neighbors(series, lfound, found, liste, box, window,
-                                  maxdim, delay, i,epsilon);
-                  iterate_points(series, lyap, count, lfound, found,
-                                 maxdim, mindim, delay, maxiter, i);
-                }
+              lfind_neighbors(series, lfound, found, liste, box, window,
+                              maxdim, delay, i,epsilon);
+              iterate_points(series, lyap, count, lfound, found,
+                             maxdim, mindim, delay, maxiter, i);
+            }
 
-              if (verbose)
-                printf("epsilon= %e\n",epsilon*max_val);
-              // Assign output
-              for (octave_idx_type i=mindim-2;i<maxdim-1;i++)
-                {
+          if (verbose)
+            printf("epsilon= %e\n",epsilon*max_val);
+          // Assign output
+          for (octave_idx_type i=mindim-2;i<maxdim-1;i++)
+            {
 
-                  // old fprintf(fout,"#epsilon= %e  dim= %d\n", 
-                  //             epsilon*max_val,i+2);
-                  octave_scalar_map tmp (keys);
-                  tmp.setfield ("eps", epsilon*max_val);
-                  tmp.setfield ("dim", i+2);
+              // old fprintf(fout,"#epsilon= %e  dim= %d\n", 
+              //             epsilon*max_val,i+2);
+              octave_scalar_map tmp (keys);
+              tmp.setfield ("eps", epsilon*max_val);
+              tmp.setfield ("dim", i+2);
 
-                  // Create matrix for the exponent data
-                  Matrix lyap_exp (maxiter + 1,3);
-                  octave_idx_type counter = 0;
-                  for (octave_idx_type j=0;j<=maxiter;j++)
-                    if (count[i][j])
-                      {
-                        // old fprintf(fout,"%d %e %ld\n",j,
-                        //             lyap[i][j]/count[i][j],count[i][j]);
+              // Create matrix for the exponent data
+              Matrix lyap_exp (maxiter + 1,3);
+              octave_idx_type counter = 0;
+              for (octave_idx_type j=0;j<=maxiter;j++)
+                if (count[i][j])
+                  {
+                    // old fprintf(fout,"%d %e %ld\n",j,
+                    //             lyap[i][j]/count[i][j],count[i][j]);
 
-                          lyap_exp(counter, 0) = j;
-                          lyap_exp(counter, 1) = lyap[i][j]/count[i][j];
-                          lyap_exp(counter, 2) = count[i][j];
-                          counter             += 1;
-                       }
-                  // Resize output to fit actual number of found exponents
-                  lyap_exp.resize(counter, 3);
-                  tmp.setfield ("exp", lyap_exp);
-                  output.assign(idx_vector(l),idx_vector(i-(int)(mindim-2)),
-                                tmp);
-                }
+                      lyap_exp(counter, 0) = j;
+                      lyap_exp(counter, 1) = lyap[i][j]/count[i][j];
+                      lyap_exp(counter, 2) = count[i][j];
+                      counter             += 1;
+                   }
+              // Resize output to fit actual number of found exponents
+              lyap_exp.resize(counter, 3);
+              tmp.setfield ("exp", lyap_exp);
+              output.assign(idx_vector(l),idx_vector(i-(int)(mindim-2)),
+                            tmp);
             }
-          // Assign output
-          retval(0) = output;
         }
+      // Assign output
+      retval(0) = output;
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lyap_r__.cc
--- a/src/__lyap_r__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lyap_r__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -167,64 +167,60 @@
       octave_idx_type maxlength=length-delay*(dim-1)-steps-1-mindist;
       bool alldone=0;
 
-      if (! error_state)
+      // Calculate the maximum epsilon that makes sense
+      // On the basis of 'i' and 'j' from put_in_boxes ()
+      NDArray input_max = input.max ();
+      double maximum_epsilon = (input_max(0) > input_max(dim-1))
+                               ? input_max(0) : input_max(dim-1);
+      maximum_epsilon *= 1.1;
+
+      // Calculate lyapunov exponents
+      for (double eps=eps0;!alldone;eps*=1.1)
         {
 
-          // Calculate the maximum epsilon that makes sense
-          // On the basis of 'i' and 'j' from put_in_boxes ()
-          NDArray input_max = input.max ();
-          double maximum_epsilon = (input_max(0) > input_max(dim-1))
-                                   ? input_max(0) : input_max(dim-1);
-          maximum_epsilon *= 1.1;
-
-          // Calculate lyapunov exponents
-          for (double eps=eps0;!alldone;eps*=1.1)
+          // If epsilon became too large 
+          // there is no sense in continuing
+          if (eps > maximum_epsilon)
             {
-
-              // If epsilon became too large 
-              // there is no sense in continuing
-              if (eps > maximum_epsilon)
-                {
-                  error_with_id ("Octave:tisean", "The neighbourhood size"
-                                 " became too large during search,"
-                                 " no sense continuing");
-                  return retval;
-                }
-
-              put_in_boxes(series, box, list, eps, length, dim, delay, steps);
-              alldone=1;
-              for (octave_idx_type n=0;n<=maxlength;n++)
-                {
-                  if (!done[n])
-                     done[n]=make_iterate(series, box, list, found, lyap, eps,
-                                          length, dim, delay, steps, mindist,
-                                          n);
-                  alldone &= done[n];
-                }
-              if (verbose)
-                printf("epsilon: %e already found: %ld\n",eps*max_val,
-                       found[0]);
+              error_with_id ("Octave:tisean", "The neighbourhood size"
+                             " became too large during search,"
+                             " no sense continuing");
+              return retval;
             }
 
-          // Create output
-          Matrix output (steps+1, 2);
-          octave_idx_type count = 0;
-          for (octave_idx_type i=0;i<=steps;i++)
-            if (found[i])
-              {
-                // old fprintf(file,"%d %e\n",i,lyap[i]/found[i]/2.0);
-                output(count,0) = i;
-                output(count,1) = lyap[i]/found[i]/2.0;
-                count          += 1;
-              }
+          put_in_boxes(series, box, list, eps, length, dim, delay, steps);
+          alldone=1;
+          for (octave_idx_type n=0;n<=maxlength;n++)
+            {
+              if (!done[n])
+                 done[n]=make_iterate(series, box, list, found, lyap, eps,
+                                      length, dim, delay, steps, mindist,
+                                      n);
+              alldone &= done[n];
+            }
+          if (verbose)
+            printf("epsilon: %e already found: %ld\n",eps*max_val,
+                   found[0]);
+        }
 
-          // Resize output to match number of found points
-          if (count < output.numel ())
-            output.resize (count, 2);
+      // Create output
+      Matrix output (steps+1, 2);
+      octave_idx_type count = 0;
+      for (octave_idx_type i=0;i<=steps;i++)
+        if (found[i])
+          {
+            // old fprintf(file,"%d %e\n",i,lyap[i]/found[i]/2.0);
+            output(count,0) = i;
+            output(count,1) = lyap[i]/found[i]/2.0;
+            count          += 1;
+          }
 
-          // Assign output
-          retval(0) = output;
-        }
+      // Resize output to match number of found points
+      if (count < output.numel ())
+        output.resize (count, 2);
+
+      // Assign output
+      retval(0) = output;
     }
   return retval;
 }
